package       misim.plugins;

import        javax.swing.*;
import        java.awt.*;
import        misim.*;
import         misim.util.*;


/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author
 * @version 1.0
 */

public class SpecialRegisterDisplay extends JPanel {

//          porta       = this.machineState.getReg( 0x05 );
//        trisa       = this.machineState.getReg( 0x85 );
//        portb       = this.machineState.getReg( 0x06 );
//        trisb       = this.machineState.getReg( 0x86 );

  // Just for now how best to make processor dependent?

  static final int PORTA    = 0x05;
  static final int PORTB    = 0x06;
  static final int TRISA    = 0x85;
  static final int TRISB    = 0x86;
  static final int STATUS   = 0x86;

   static final int FSR     = 0x03;
   static final int TMR0    = 0x01;
   static final int PLC     = 0x02;

  GridLayout gridLayout1 = new GridLayout();


  JLabel jLabel1 = new JLabel();
  JLabel jLWBin = new JLabel();
  JLabel jLWHex = new JLabel();
  JLabel jLW = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLStatus = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLStatusHex = new JLabel();
  JLabel jLStatusBin = new JLabel();
  JLabel jLPortA = new JLabel();
  JLabel jLPortAHex = new JLabel();
  JLabel jLabel10 = new JLabel();
  JLabel jLProgCountHex = new JLabel();
  JLabel jLProgCountBin = new JLabel();


  JLabel jLPortABin = new JLabel();

  JLabel jLPortB        = new JLabel();
  JLabel jLPortBBin     = new JLabel();
  JLabel jLPortBHex     = new JLabel();

  JLabel jLFsr          = new JLabel();
  JLabel jLFsrBin       = new JLabel();
  JLabel jLFsrHex       = new JLabel();

  JLabel jLTmr0         = new JLabel();
  JLabel jLTmr0Bin      = new JLabel();
  JLabel jLTmr0Hex      = new JLabel();

  JLabel jLPlc          = new JLabel();
  JLabel jLPlcBin       = new JLabel();
  JLabel jLPlcHex       = new JLabel();


  public SpecialRegisterDisplay() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }


  }

 // ---------------------------

   public void updateDisplay( MachineState machineState )   {

        //String      locString;
        int         locInt;


        // ---------------------------------

        //locString		= Util.wordString( machineState.getPC( ) );
        locInt                 = machineState.getPC( );
        this.jLProgCountHex.setText( Util.wordString( locInt ) );

        //locString		= Util.byteString( machineState.getW() );
        //this.jLWHex.setText( Util.byteString( );

        // status    jLStatusHex


        locInt                  = machineState.getW();
        this.jLWHex.setText( Util.byteString( locInt ) );
        this.jLWBin.setText( Util.binaryString( locInt ) );

        locInt                  = machineState.getReg( PORTA );
        this.jLPortAHex.setText( Util.byteString(    locInt ) );
        this.jLPortABin.setText( Util.binaryString(  locInt ) );

        locInt                  = machineState.getReg( PORTB );
        jLPortBHex.setText( Util.byteString(    locInt ) );
        jLPortBBin.setText( Util.binaryString(  locInt ) );

        locInt                  = machineState.getReg( FSR );
        jLFsrHex.setText( Util.byteString(    locInt ) );
        jLFsrBin.setText( Util.binaryString(  locInt ) );

        locInt                  = machineState.getReg( TMR0 );
        jLTmr0Hex.setText( Util.byteString(    locInt ) );
        jLTmr0Bin.setText( Util.binaryString(  locInt ) );

        locInt                  = machineState.getReg( PLC );
        jLPlcHex.setText( Util.byteString(    locInt ) );
        jLPlcBin.setText( Util.binaryString(  locInt ) );

        locInt                  = machineState.getReg( STATUS );
        jLStatusHex.setText( Util.byteString(    locInt ) );
        jLStatusBin.setText( Util.binaryString(  locInt ) );

   }


 // --------------------------

  private void jbInit() throws Exception {
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setText("Register");
    this.setLayout(gridLayout1);
    jLW.setText("W");
    jLabel5.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel5.setText("Hex");
    gridLayout1.setRows(9);
    gridLayout1.setColumns(3);
    jLStatus.setText("Status");
    jLabel7.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel7.setText("Bin");
    jLPortA.setText("PORTA");
    jLabel10.setText("ProgCount");
    jLProgCountHex.setText("progconthex");


    jLPortB.setText("PORTB");
    jLFsr.setText("FSR");
    jLTmr0.setText("TMR0");
    jLPlc.setText("PLC");
    jLProgCountBin.setText("-");
    this.add(jLabel1, null);
    this.add(jLabel5, null);
    this.add(jLabel7, null);
    this.add(jLabel10, null);
    this.add(jLProgCountHex, null);
    this.add(jLProgCountBin, null);
    this.add(jLW, null);
    this.add(jLWHex, null);
    this.add(jLWBin, null);
    this.add(jLStatus, null);
    this.add(jLStatusHex, null);
    this.add(jLStatusBin, null);


    this.add(jLPortA, null);
    this.add(jLPortAHex, null);
    this.add(jLPortABin, null);


    this.add(jLPortB, null);
    this.add(jLPortBHex, null);
    this.add(jLPortBBin, null);


    this.add( jLFsr,      null );
    this.add( jLFsrHex,   null );
    this.add( jLFsrBin,   null );

    this.add( jLTmr0,     null );
    this.add( jLTmr0Hex,  null );
    this.add( jLTmr0Bin,  null );

    this.add( jLPlc,      null );
    this.add( jLPlcHex,   null );
    this.add( jLPlcBin,   null );


  }
}



